﻿using System;
using System.Text;
using System.Net;
using System.IO;
using System.Security.Cryptography;
using System.Drawing;

/**
 * @author she
 */
namespace POSCOMPrint
{

    class test
    {
        public static string IP = "http://api.poscom.cn";       //接口IP或域名
        public static string Port = "80";                //端口
        public static string apiKey = "xxxxxxxxxxxxxxxxxxxxx";    //*必填*：注册账号后生成的API密钥
        public static string memberCode = "xxxxxxxxxxxxxxxxxxxxx";//*必填*: 注册账号后生成的商户编号
        public static string deviceID = "xxxxxxxxxxxxxxxxxxxxx";        //*必填*：打印机编号，必须要在管理后台里手动添加打印机或者通过API添加之后，才能调用API

        //**********测试时，打开下面注释掉方法的即可**********
        static void Main(string[] args)
        {
            //============添加打印机========================
            //***返回值JSON字符串***
            //正确：{"code":1, "msg":"添加成功", "devID":114}
            //错误：{"code" : -4, "msg": "安全校验码不正确。"}

            //string resultAdddev = adddev(deviceID);
            //System.Console.WriteLine(resultAdddev);

            //============打印订单==========================
            //***返回值JSON字符串***
            //正确：{"code" : 1, "msg": "“正常。"}
            //错误：{"code" : -2, "msg": "关键参数为空或请求方式不对。"}

            //string resultSendMsg = sendMsg();
            //System.Console.WriteLine(resultSendMsg);


            //===========查询某订单是否打印成功=============
            //***返回值JSON字符串***
            //正确：{"code" : 1, "msg": "打印任务已完成，请求数据已打印。"}
            //错误：{"code" : -4, "msg": "安全校验码不正确。"}

            //string msgNo = "1000002031031219";//订单ID
            //string resultQueryState = queryState(msgNo);
            //System.Console.WriteLine(resultQueryState);

            //===========查询打印机的状态==========================
            //***返回值JSON字符串***
            //正确：{"code":1, "msg":"查询成功", "statusList":[{"deviceID":"xxxxxxxxxxxxxxxxx":0,"status":0,"outtime":"2019-03-30 15:59:05","printnum":267}]}
            //错误：{"code" : -4, "msg": "安全校验码不正确。"}

            //string resultGetStatus = getStatus();
            //System.Console.WriteLine(resultGetStatus);

            //==========条码打印机图片转指令======================
            //StreamWriter sw = new StreamWriter(@"C:\Users\windows\Desktop\PoscomImageOutput.txt");
            //Console.SetOut(sw);

            //string[] resultImage = getHttpImageLabelStr("../../www.poscom.cn.jpg");
            //System.Console.Write("^XA^MCY^MTD^MD10^LT0^MMT^MNN^PW600^LL264^PR3^PMN^POI^JMA^LH0,0^LRN^CWA,Z:MSUNG.FNT^CWB,Z:MSUNG.FNT^CI28^XZ");
            //~DG下载图象
            //System.Console.Write("~DGGRAPHIC1," + resultImage[2].Length / 2 + "," + resultImage[0] + "," + resultImage[2].ToString());
            //System.Console.Write("^XA^FO33,16^XGGRAPHIC1^FS^PQ1,0,1,Y^XZ");

            //sw.Flush();
            //sw.Close();

        }


        //====================以下是函数实现部分==========================
        // 添加设备
        private static string adddev(string deviceId)
        {
            string URL = IP + ":" + Port + "/apisc/adddev";
            HttpWebRequest req = (HttpWebRequest)HttpWebRequest.Create(URL);
            req.Method = "POST";

            UTF8Encoding encoding = new UTF8Encoding();

            string postData = "";

            long itime = DateTimeToStamp();
            string reqTime = itime.ToString();
            string securityCode = MD5POSCOM(memberCode + reqTime + apiKey + deviceId);
            string devName = deviceId;

            //所有参数
            postData += ("memberCode=" + memberCode);
            postData += ("&reqTime=" + reqTime);
            postData += ("&securityCode=" + securityCode);
            postData += ("&deviceID=" + deviceId);
            postData += ("&devName=" + devName);

            byte[] data = encoding.GetBytes(postData);

            req.ContentType = "application/x-www-form-urlencoded";
            req.ContentLength = data.Length;
            Stream resStream = req.GetRequestStream();

            resStream.Write(data, 0, data.Length);
            resStream.Close();

            HttpWebResponse response;
            string strResult;
            try
            {
                response = (HttpWebResponse)req.GetResponse();
                StreamReader reader = new StreamReader(response.GetResponseStream(), Encoding.UTF8);
                strResult = reader.ReadToEnd();
            }
            catch (WebException ex)
            {
                response = (HttpWebResponse)ex.Response;
                strResult = response.StatusCode.ToString();//错误信息
            }

            response.Close();
            req.Abort();

            return strResult;
        }


        // 发送数据到打印机
        private static string sendMsg()
        {
            //标签说明
            //==========以下自定义标签只适用于票据打印机，各参数值及说明请看API文档==========

            //条码: <gpBarCode Type=x Height=y Position=z>条码内容</gpBarCode>
            //      <gpBarCode Align=a Type=x Width=y Height=z Position=p>条码内容</gpBarCode>

            //二维码：<gpQRCode>二维码内容</gpQRCode>
            //        <gpQRCode Align=a Size=x Error=y>二维码内容</gpQRCode>

            //文本：<gpWord Align=a Bold=x Wsize=y Hsize=z Reverse=k Underline=j>文本内容</gpWord>
            //图片：<gpImg Align=a>图片URL</gpImg>
            //一行两列：<gpTR2 Type=a><td>内容1</td><td>内容2</td></gpTR2>
            //一行三列: <gpTR3 Type=a><td>内容1</td><td>内容2</td><td>内容3</td></gpTR3>
            //换行: <gpBr/>
            //切刀: <gpCut/>
            //打印LOGO: <gpLogo/>
            //钱箱 声光报警器：<gpCashBox/>

            //==========以上自定义标签只适用于票据打印机，各参数值及说明请看API文档==========

            string msgDetail;
            //【# mode=2 & 58mm票据打印机(GP-5890XIII、GP-58130IVC、GP-SH584、GC-586、TD-2270票据模式)】拼凑订单内容时可参考如下格式
            msgDetail = "<gpLogo/><gpWord Align=1 Bold=1 Wsize=2 Hsize=2 Reverse=0 Underline=0>发货单</gpWord>\r\n";
            msgDetail += "<gpBarCode Align=1 Type=7 Width=2 Height=80 Position=0>201811080001</gpBarCode>";
            msgDetail += "<gpWord Align=0 Bold=0 Wsize=0 Hsize=0 Reverse=0 Underline=0>订单编号：201811080001</gpWord>";
            msgDetail += "<gpWord Align=0 Bold=0 Wsize=0 Hsize=0 Reverse=0 Underline=0>买家姓名：张三</gpWord>";
            msgDetail += "<gpWord Align=0 Bold=0 Wsize=0 Hsize=0 Reverse=0 Underline=0>买家手机：18666666666</gpWord>";
            msgDetail += "<gpWord Align=0 Bold=1 Wsize=0 Hsize=1 Reverse=0 Underline=0>买家留言：发顺丰,尽快发货，谢谢</gpWord>";
            msgDetail += "<gpWord Align=0 Bold=1 Wsize=0 Hsize=1 Reverse=0 Underline=0>卖家备注：发顺丰，优先处理</gpWord>";
            msgDetail += "<gpWord Align=0 Bold=1 Wsize=0 Hsize=1 Reverse=0 Underline=0>买就送信息：送U盘</gpWord>";
            msgDetail += "<gpWord Align=0 Bold=0 Wsize=0 Hsize=0 Reverse=0 Underline=0>--------------------------------</gpWord>";
            msgDetail += "<gpTR4 Type=0><td>宝贝名称</td><td>单价</td><td>数量</td><td>价格</td></gpTR4>";
            msgDetail += "<gpTR4 Type=0><td>佳博GP-CH421D云打印机</td><td>1180</td><td>1</td><td>1180</td></gpTR4>";
            msgDetail += "<gpTR4 Type=0><td>佳博GP-5890XIII云打印机</td><td>480</td><td>1</td><td>480</td></gpTR4>";
            msgDetail += "<gpTR4 Type=0><td>佳博G3-350V云打印机</td><td>980</td><td>1</td><td>980</td></gpTR4>";
            msgDetail += "<gpTR4 Type=0><td>100x150热敏标签纸300</td><td>36</td><td>10</td><td>360</td></gpTR4>";
            msgDetail += "<gpTR4 Type=0><td>58毫米热敏卷纸100米</td><td>48</td><td>5</td><td>240</td></gpTR4>";
            msgDetail += "<gpTR4 Type=0><td>80毫米热敏卷纸100米</td><td>42</td><td>10</td><td>420</td></gpTR4>";
            msgDetail += "<gpWord Align=0 Bold=0 Wsize=0 Hsize=0 Reverse=0 Underline=0>-------------------------------- </gpWord>";
            msgDetail += "<gpWord Align=2 Bold=0 Wsize=0 Hsize=0 Reverse=0 Underline=0>合计：3660元</gpWord>";
            msgDetail += "<gpWord Align=2 Bold=0 Wsize=0 Hsize=0 Reverse=0 Underline=0>优惠：-198元</gpWord>";
            msgDetail += "<gpWord Align=2 Bold=0 Wsize=0 Hsize=0 Reverse=0 Underline=0>邮费：  30元</gpWord>";
            msgDetail += "<gpWord Align=2 Bold=1 Wsize=1 Hsize=1 Reverse=0 Underline=0>实收：3492元 </gpWord>\r\n";
            msgDetail += "<gpCut/>";
            msgDetail += "<gpWord Align=1 Bold=1 Wsize=1 Hsize=1 Reverse=0 Underline=0>扫码关注佳博</gpWord>\r\n";
            msgDetail += "<gpQRCode Align=1 Size=9 Error=M>http://weixin.qq.com/r/kHV3b67EXPMjreoM9yCC</gpQRCode>";
            msgDetail += "<gpCut/>";

            //【# mode=2 & 80mm票据打印机(G3-350v、EVA G)】拼凑订单内容时可参考如下格式
            //msgDetail = "<gpLogo/><gpWord Align=1 Bold=1 Wsize=2 Hsize=2 Reverse=0 Underline=0>发货单</gpWord>\r\n";
            //msgDetail += "<gpBarCode Align=1 Type=7 Width=2 Height=80 Position=0>201811080001</gpBarCode>";
            //msgDetail += "<gpWord Align=0 Bold=0 Wsize=0 Hsize=0 Reverse=0 Underline=0>订单编号：201811080001</gpWord>";
            //msgDetail += "<gpWord Align=0 Bold=0 Wsize=0 Hsize=0 Reverse=0 Underline=0>买家姓名：张三</gpWord>";
            //msgDetail += "<gpWord Align=0 Bold=0 Wsize=0 Hsize=0 Reverse=0 Underline=0>买家手机：18666666666</gpWord>";
            //msgDetail += "<gpWord Align=0 Bold=1 Wsize=0 Hsize=1 Reverse=0 Underline=0>买家留言：发顺丰,尽快发货，谢谢</gpWord>";
            //msgDetail += "<gpWord Align=0 Bold=1 Wsize=0 Hsize=1 Reverse=0 Underline=0>卖家备注：发顺丰，优先处理</gpWord>";
            //msgDetail += "<gpWord Align=0 Bold=1 Wsize=0 Hsize=1 Reverse=0 Underline=0>买就送信息：送U盘</gpWord>";
            //msgDetail += "<gpWord Align=0 Bold=0 Wsize=0 Hsize=0 Reverse=0 Underline=0>--------------------------------</gpWord>";
            //msgDetail += "<gpTR4 Type=1><td>宝贝名称</td><td>单价</td><td>数量</td><td>价格</td></gpTR4>";
            //msgDetail += "<gpTR4 Type=1><td>佳博GP-CH421D云打印机</td><td>1180</td><td>1</td><td>1180</td></gpTR4>";
            //msgDetail += "<gpTR4 Type=1><td>佳博GP-5890XIII云打印机</td><td>480</td><td>1</td><td>480</td></gpTR4>";
            //msgDetail += "<gpTR4 Type=1><td>佳博G3-350V云打印机</td><td>980</td><td>1</td><td>980</td></gpTR4>";
            //msgDetail += "<gpTR4 Type=1><td>100x150热敏标签纸300</td><td>36</td><td>10</td><td>360</td></gpTR4>";
            //msgDetail += "<gpTR4 Type=1><td>58毫米热敏卷纸100米</td><td>48</td><td>5</td><td>240</td></gpTR4>";
            //msgDetail += "<gpTR4 Type=1><td>80毫米热敏卷纸100米</td><td>42</td><td>10</td><td>420</td></gpTR4>";
            //msgDetail += "<gpWord Align=0 Bold=0 Wsize=0 Hsize=0 Reverse=0 Underline=0>-------------------------------- </gpWord>";
            //msgDetail += "<gpWord Align=2 Bold=0 Wsize=0 Hsize=0 Reverse=0 Underline=0>合计：3660元</gpWord>";
            //msgDetail += "<gpWord Align=2 Bold=0 Wsize=0 Hsize=0 Reverse=0 Underline=0>优惠：-198元</gpWord>";
            //msgDetail += "<gpWord Align=2 Bold=0 Wsize=0 Hsize=0 Reverse=0 Underline=0>邮费：  30元</gpWord>";
            //msgDetail += "<gpWord Align=2 Bold=1 Wsize=1 Hsize=1 Reverse=0 Underline=0>实收：3492元 </gpWord>\r\n";
            //msgDetail += "<gpCut/>";
            //msgDetail += "<gpWord Align=1 Bold=1 Wsize=1 Hsize=1 Reverse=0 Underline=0>扫码关注佳博</gpWord>\r\n";
            //msgDetail += "<gpQRCode Align=1 Size=9 Error=M>http://weixin.qq.com/r/kHV3b67EXPMjreoM9yCC</gpQRCode>";
            //msgDetail += "<gpCut/>";

            //【# mode=2 & TSPL标签打印机(GP-TD2270、GP-305T、S-4342)】发送打印内容可参考如下
            //msgDetail = "SIZE 35 mm,45 mm\r\n";
            //msgDetail += "GAP 0 mm,0 mm\r\n";
            //msgDetail += "REFERENCE 0,0\r\n";
            //msgDetail += "SPEED 4\r\n";
            //msgDetail += "DENSITY 8\r\n";
            //msgDetail += "DIRECTION 0\r\n";
            //msgDetail += "SET HEAD ON\r\n";
            //msgDetail += "SET PRINTKEY OFF\r\n";
            //msgDetail += "SET KEY1 ON\r\n";
            //msgDetail += "SET KEY2 ON\r\n";
            //msgDetail += "SHIFT 0\r\n";
            //msgDetail += "CLS\r\n";
            //msgDetail += "TEXT 180,10,\"TSS24.BF2\",0,1,1,\"0\"\r\n";
            //msgDetail += "TEXT 30,10,\"TSS24.BF2\",0,1,1,\"佳博云打印,无线聚商机\"\r\n";
            //msgDetail += "BARCODE 30,75,\"128\",64,1,0,2,4,\"200902125410\"\r\n";
            //msgDetail += "QRCODE 30,180,L,6,A,0,\"cloud.poscom.cn\"\r\n";
            //msgDetail += "TEXT 220,180,\"TSS24.BF2\",90,2,2,\"请扫码\"\r\n";
            //msgDetail += "PRINT 1,1\r\n";

            //【# mode=2 & ZPL标签打印机(GP-CH421D)】发送打印内容可参考如下
            //msgDetail = "^XA^MCY^MTD^MD20^LT0^MMT^MNN^PW320^LL242^PR2^PMN^PON^JMA^LH0,4^LRN^CWA,Z:MSUNG.FNT^CI28^XZ";
            //msgDetail += "^XA";
            //msgDetail += "^FO0,136^GB320,0,2^FS";
            //msgDetail += "^FO136,0^GB0,136,2^FS";
            //msgDetail += "^FO6,3^BQ,1,6,L,7^FDLA,www.poscom.cn^FS";
            //msgDetail += "^FO148,8^AA,32,32^FD佳博云打印^FS";
            //msgDetail += "^FO160,46^AA,28,28^FD无线聚商机^FS";
            //msgDetail += "^FO142,80^AA,20,20^FD远程打印、随时打印^FS";
            //msgDetail += "^FO142,110^AA,20,20^FD无人值守、自动打印^FS";
            //msgDetail += "^FO4,140^BY2,2.4^BCN,70,Y,N,N,N ^FD>:70024523647^FS";
            //msgDetail += "^XZ";


            msgDetail = Uri.EscapeDataString(msgDetail);
            string URL = IP + ":" + Port + "/apisc/sendMsg";
            HttpWebRequest req = (HttpWebRequest)HttpWebRequest.Create(URL);
            req.Method = "POST";
            UTF8Encoding encoding = new UTF8Encoding();

            int charset = 1; //编码
            //打印模式
            //mode=2模式适用于票据打印机自定义标签或条码打印机编程指令
            //mode=3模式使用于票据打印机编程指令，十六进制数据值字符串，无空格，如十六进制 0x12 0xAB 0xCD 0xEF，发送内容 12ABCDEF
            int mode = 2; 
            long itime = DateTimeToStamp();
            string reqTime = itime.ToString();
            string msgNo = reqTime; //自定义订单编号
            string securityCode = MD5POSCOM(memberCode + deviceID + msgNo + reqTime + apiKey);
            string postData = "";
            //参数
            postData += ("charset=" + charset); //编码（*必填）
            postData += ("&reqTime=" + reqTime);//时间戳精确到毫秒（*必填）
            postData += ("&memberCode=" + memberCode);//商户编码（ *必填）
            postData += ("&deviceID=" + deviceID);//设备编号（*必填）
            postData += ("&securityCode=" + securityCode);//安全校验码（*必填）
            postData += ("&msgDetail=" + msgDetail);//打印内容（ *必填）
            postData += ("&mode=" + mode);//打印模式（*必填）
            postData += ("&msgNo=" + msgNo);//自定义订单号（选填）
            postData += ("&times=" + 1); //多联（选填），默认为1
            postData += ("&reprint="); //是否重新打印（选填），不验证自定义订单号

            byte[] data = encoding.GetBytes(postData);

            req.ContentType = "application/x-www-form-urlencoded";
            req.ContentLength = data.Length;
            Stream resStream = req.GetRequestStream();

            resStream.Write(data, 0, data.Length);
            resStream.Close();

            HttpWebResponse response;
            string strResult;
            try
            {
                response = (HttpWebResponse)req.GetResponse();
                StreamReader reader = new StreamReader(response.GetResponseStream(), Encoding.UTF8);
                strResult = reader.ReadToEnd();
            }
            catch (WebException ex)
            {
                response = (HttpWebResponse)ex.Response;
                strResult = response.StatusCode.ToString();//错误信息
            } 

			response.Close();
            req.Abort();
            //服务器返回的JSON字符串，建议要当做日志记录起来
            return strResult;

        }


        // 查询打印任务状态
        private static string queryState(string msgNo)
        {
            string URL = IP + ":" + Port + "/apisc/queryState";
            long itime = DateTimeToStamp();
            string reqTime = itime.ToString();
            string securityCode = MD5POSCOM(memberCode + reqTime + apiKey + msgNo);
            string postData = "";

            //参数
            postData += "?msgNo=" + msgNo;
            postData += ("&memberCode=" + memberCode);
            postData += ("&reqTime=" + reqTime);
            postData += ("&securityCode=" + securityCode);

            URL += postData;
            HttpWebRequest req = (HttpWebRequest)HttpWebRequest.Create(URL);
            req.Method = "GET";
            req.ContentType = "application/x-www-form-urlencoded";

            HttpWebResponse response;
            string strResult;
            try
            {
                response = (HttpWebResponse)req.GetResponse();
                StreamReader reader = new StreamReader(response.GetResponseStream(), Encoding.UTF8);
                strResult = reader.ReadToEnd();
            }
            catch (WebException ex)
            {
                response = (HttpWebResponse)ex.Response;
                strResult = response.StatusCode.ToString();//错误信息
            }

            response.Close();
            req.Abort();

            return strResult;
        }

        // 获取打印机状态
        private static string getStatus()
        {
            string URL = IP + ":" + Port + "/apisc/getStatus";
            HttpWebRequest req = (HttpWebRequest)HttpWebRequest.Create(URL);
            req.Method = "POST";

            UTF8Encoding encoding = new UTF8Encoding();

           long itime = DateTimeToStamp();
            string reqTime = itime.ToString();
            string securityCode = MD5POSCOM(memberCode + reqTime + apiKey );
            string postData = "";

            //参数
            postData += ("memberCode=" + memberCode);
            postData += ("&reqTime=" + reqTime);
            postData += ("&securityCode=" + securityCode);
            postData += ("&deviceID=" + deviceID);

            byte[] data = encoding.GetBytes(postData);

            req.ContentType = "application/x-www-form-urlencoded";
            req.ContentLength = data.Length;
            Stream resStream = req.GetRequestStream();

            resStream.Write(data, 0, data.Length);
            resStream.Close();

            HttpWebResponse response;
            string strResult;
            try
            {
                response = (HttpWebResponse)req.GetResponse();
                StreamReader reader = new StreamReader(response.GetResponseStream(), Encoding.UTF8);
                strResult = reader.ReadToEnd();
            }
            catch (WebException ex)
            {
                response = (HttpWebResponse)ex.Response;
                strResult = response.StatusCode.ToString();//错误信息
            }

            response.Close();
            req.Abort();

            return strResult;

        }

        // 校验
        public static string MD5POSCOM(string stringToHash)
        {
            var md5 = new System.Security.Cryptography.MD5CryptoServiceProvider();
            byte[] emailBytes = Encoding.UTF8.GetBytes(stringToHash);
            byte[] hashedEmailBytes = md5.ComputeHash(emailBytes);
            StringBuilder sb = new StringBuilder();
            foreach (var b in hashedEmailBytes)
            {
                sb.Append(b.ToString("x2").ToLower());
            }
            return sb.ToString();
        }

        // 时间戳秒数
        private static long DateTimeToStamp()
        {
            return (DateTime.Now.ToUniversalTime().Ticks - 621355968000000000) / 10000;
        }


        // 【标签打印机】打开图片并生成图片打印指令内容
        public static String[] getHttpImageLabelStr(String imgUrl) {

            Bitmap bi = ReadImageFile(imgUrl);
            int width = bi.Size.Width;
            int height = bi.Size.Height;
    		int wModByte = (width%8)==0 ? 0 : 8-(width%8);
    		int hModByte = (height%8)==0 ? 0 : 8-(height%8);
    		int wPrintByte = (width+wModByte)/8;
    		int hPrintByte = (height+hModByte)/8;

            StringBuilder res = new StringBuilder();
            Color myColor = new Color();
            int[] rgb = new int[3];
    		for (int y = 0; y < height; y++) {
    			for (int x = 0; x < width; x++) {
                    myColor = bi.GetPixel(x, y);
                    String bitStr = (myColor.R + myColor.G + myColor.B) / 3 >= 200 ? "0" : "1";
                    res.Append(bitStr);
    			}
    			for (int x = 0; x < wModByte; x++){
                    res.Append("0");
    			}
    		}
    		int ModWidth = width+wModByte;
    		for (int y = 0; y < hModByte; y++){
    			for (int x = 0; x < ModWidth; x++){
                    res.Append("0");
    			}
    		}

            string bitString = res.ToString();
            StringBuilder hexStr = new StringBuilder();
            int length = bitString.Length;
    		for (int i = 0; i < length; i+=4){
                String bitTmp = bitString.Substring(i, 4);
                String hex = Convert.ToInt32(bitTmp, 2).ToString("x");
    			hexStr.Append(hex);
    		}

    		String[] getHttpImageLabelStr = new String[3];
            getHttpImageLabelStr[0] = wPrintByte.ToString();
            getHttpImageLabelStr[1] = hPrintByte.ToString();
    		getHttpImageLabelStr[2] = hexStr.ToString();
    		return getHttpImageLabelStr;
	    }

        // 通过FileStream 来打开文件
        public static Bitmap ReadImageFile(string path)
        {
            FileStream fs = File.OpenRead(path); //OpenRead
            int filelength = 0;
            filelength = (int)fs.Length; //获得文件长度 
            Byte[] image = new Byte[filelength]; //建立一个字节数组 
            fs.Read(image, 0, filelength); //按字节流读取 
            System.Drawing.Image result = System.Drawing.Image.FromStream(fs);
            fs.Close();
            Bitmap bit = new Bitmap(result);
            return bit;
        }

    }


}